################################################################################
# Copyright © 2017-2018 Université de technologie de Troyes,
# Copyright © 2016-2017 Université de Versailles Saint-Quentin-en-Yvelines,
# Copyright © 2013-2018 CNRS,
# Copyright © 2013-2016 Université de Nantes.
# Author: Florian Blachère
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

option(ENABLE_COVERAGE "Enable code coverage" OFF)
if(ENABLE_COVERAGE)
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS_COVERAGE} ${CMAKE_Fortran_FLAGS}")
  #"
  if(${CMAKE_Fortran_COMPILER_ID} MATCHES "GNU")
    find_program(GCOV gcov)
    if (GCOV-NOTFOUND)
    else()
      add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src/main.f90.gcda
        OUTPUT ${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src/main.f90.gcno
        DEPENDS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${PROJECT_NAME}
        DEPENDS ${PROJECT_OUT_DIR}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

      find_program(LCOV lcov)
      find_program(GENHTML genhtml)
      if (LCOV-NOTFOUND OR GENHTML-NOTFOUND)
      else()
        add_custom_target(coverage_lcov
          COMMAND ${CMAKE_COMMAND} -E make_directory lcov
          COMMAND ${LCOV} --gcov-tool ${GCOV} --quiet --capture --directory
          ${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src
          --output-file lcov/coverage.info
          COMMAND ${LCOV} --gcov-tool ${GCOV} --quiet --list lcov/coverage.info
          COMMAND ${GENHTML} --quiet --output-directory lcov lcov/coverage.info
          COMMAND ${CMAKE_COMMAND} -E echo "Code coverage done, you can look at: file://${CMAKE_BINARY_DIR}/lcov/index.html with your favorite browser"
          #"
          DEPENDS ${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src/main.f90.gcda
          DEPENDS ${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src/main.f90.gcno
          WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
      endif()

      find_program(GCOVR gcovr)
      if(GCOVR-NOTFOUND)
      else()
        add_custom_target(coverage_gcovr
          COMMAND ${CMAKE_COMMAND} -E make_directory gcovr
          COMMAND ${GCOVR} --gcov-executable=${GCOV} --root=${CMAKE_SOURCE_DIR}/src
          --object-directory=${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src
          COMMAND ${GCOVR} --gcov-executable=${GCOV} --root=${CMAKE_SOURCE_DIR}/src
          --object-directory=${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src
          --html --html-details -o gcovr/index.html
          #-s
          COMMAND ${CMAKE_COMMAND} -E echo "Code coverage done, you can look at: file://${CMAKE_BINARY_DIR}/gcovr/index.html with your favorite browser"
          #"
          DEPENDS ${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src/main.f90.gcda
          DEPENDS ${CMAKE_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}.dir/src/main.f90.gcno
          WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
      endif()
    endif()
  elseif(${CMAKE_Fortran_COMPILER_ID} MATCHES "Intel")
    message(FATAL_ERROR "Code coverage not yet implemented with Intel compilers")
  endif()
endif()
