################################################################################
# Copyright © 2017-2018 Université de technologie de Troyes,
# Copyright © 2016-2017 Université de Versailles Saint-Quentin-en-Yvelines,
# Copyright © 2013-2018 CNRS,
# Copyright © 2013-2016 Université de Nantes.
# Author: Florian Blachère
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

string(TIMESTAMP CMAKE_TIMESTAMP %Y%m%d%H%M%S)

option(ENABLE_PROFILING "Enable profiling" OFF)
if(ENABLE_PROFILING)
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS_PROFILING} ${CMAKE_Fortran_FLAGS}")
  #"
  find_program(GPROF gprof)
  if(GPROF-NOTFOUND)
    message(FATAL_ERROR "gprof is needed to profile the code")
  else()
    add_custom_command(OUTPUT gprof/gmon_${CMAKE_TIMESTAMP}.out
      COMMAND ${CMAKE_COMMAND} -E make_directory gprof
      COMMAND ${CMAKE_COMMAND} -E rename gmon.out gprof/gmon_${CMAKE_TIMESTAMP}.out
      DEPENDS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${PROJECT_NAME}
      DEPENDS ${PROJECT_OUT_DIR})
    add_custom_target(profiling
      COMMAND ${GPROF} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${PROJECT_NAME}
      gprof/gmon_${CMAKE_TIMESTAMP}.out > gprof/gprof_log_${CMAKE_TIMESTAMP}
      COMMAND ${CMAKE_COMMAND} -E echo "Profiling done see 'gprof/gprof_log_${CMAKE_TIMESTAMP}'"
      #"
      DEPENDS gprof/gmon_${CMAKE_TIMESTAMP}.out
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
  endif()

  #if(${CMAKE_Fortran_COMPILER_ID} MATCHES "PGI")
    #find_program(PGPROF pgprof)
    #if(PGPROF-NOTFOUND)
    #else()
      #set(PREFIX_COMMAND ${PGPROF} -o ${PROJECT_NAME}.prof)
      #add_custom_command(OUTPUT gprof/gmon_${CMAKE_TIMESTAMP}.out
        #COMMAND ${CMAKE_COMMAND} -E make_directory gprof
        #COMMAND ${CMAKE_COMMAND} -E rename gmon.out gprof/gmon_${CMAKE_TIMESTAMP}.out
        #DEPENDS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${PROJECT_NAME}
        #DEPENDS ${PROJECT_OUT_DIR})
      #add_custom_target(profiling
        #COMMAND ${GPROF} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${PROJECT_NAME}
        #gprof/gmon_${CMAKE_TIMESTAMP}.out > gprof/gprof_log_${CMAKE_TIMESTAMP}
        #COMMAND ${CMAKE_COMMAND} -E echo "Profiling done see 'gprof/gprof_log_${CMAKE_TIMESTAMP}'"
        ##"
        #DEPENDS gprof/gmon_${CMAKE_TIMESTAMP}.out
        #WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    #endif()
  #endif()
endif()
