################################################################################
# Copyright © 2017-2018 Université de technologie de Troyes,
# Copyright © 2016-2017 Université de Versailles Saint-Quentin-en-Yvelines,
# Copyright © 2013-2018 CNRS,
# Copyright © 2013-2016 Université de Nantes.
# Author: Florian Blachère
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

find_program(PANDOC_EXECUTABLE pandoc)
if(PANDOC_EXECUTABLE-NOTFOUND)
else()
  add_custom_target(md2html
    COMMAND ${PANDOC_EXECUTABLE} --from markdown_github-hard_line_breaks --to html --standalone
    ${CMAKE_SOURCE_DIR}/README.md --output README.html
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

  add_custom_target(md2odt
    COMMAND ${PANDOC_EXECUTABLE} --from markdown_github-hard_line_breaks --to odt
    ${CMAKE_SOURCE_DIR}/README.md --output README.odt
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

  add_custom_target(md2pdf
    COMMAND ${PANDOC_EXECUTABLE} --from markdown_github-hard_line_breaks --to latex --standalone
    ${CMAKE_SOURCE_DIR}/README.md --output README.pdf
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

  add_custom_target(md2txt
    COMMAND ${PANDOC_EXECUTABLE} --from markdown_github-hard_line_breaks --to plain --standalone
    ${CMAKE_SOURCE_DIR}/README.md --output README.txt
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
endif()
