/**
 * @brief Check version of gcc
 * (inspired from petscversion.h)
 *
 * @author Florian Blachère
 *
 * @copyright © 2017-2018 Université de technologie de Troyes,
 * @copyright © 2016-2017 Université de Versailles Saint-Quentin-en-Yvelines,
 * @copyright © 2013-2018 CNRS,
 * @copyright © 2013-2016 Université de Nantes.
 * @copyright This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * @copyright This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * @copyright You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define _GNUC_VERSION_(MAJOR,MINOR,PATCH) \
  ((__GNUC__ == (MAJOR)) &&               \
   (__GNUC_MINOR__ == (MINOR)) &&         \
   (__GNUC_PATCHLEVEL__ == (PATCH)))

#define _GNUC_VERSION_LT_(MAJOR,MINOR,PATCH) \
  (__GNUC__ < (MAJOR) ||                     \
   (__GNUC__ == (MAJOR) &&                   \
    (__GNUC_MINOR__ < (MINOR) ||             \
     (__GNUC_MINOR__ == (MINOR) &&           \
      (__GNUC_PATCHLEVEL__ < (PATCH))))))

#define _GNUC_VERSION_LE_(MAJOR,MINOR,PATCH) \
  (_GNUC_VERSION_LT_(MAJOR,MINOR,PATCH) ||   \
   _GNUC_VERSION_(MAJOR,MINOR,PATCH))

#define _GNUC_VERSION_GT_(MAJOR,MINOR,PATCH) \
  (0 == _GNUC_VERSION_LE_(MAJOR,MINOR,PATCH))

#define _GNUC_VERSION_GE_(MAJOR,MINOR,PATCH) \
  (0 == _GNUC_VERSION_LT_(MAJOR,MINOR,PATCH))
