!> Main file
!>
!> @author Florian Blachère
!>
!> @copyright © 2017-2018 Université de technologie de Troyes,
!> @copyright © 2016-2017 Université de Versailles Saint-Quentin-en-Yvelines,
!> @copyright © 2013-2018 CNRS,
!> @copyright © 2013-2016 Université de Nantes.
!> @copyright This program is free software: you can redistribute it and/or modify
!> it under the terms of the GNU General Public License as published by
!> the Free Software Foundation, either version 3 of the License, or
!> (at your option) any later version.
!>
!> @copyright This program is distributed in the hope that it will be useful,
!> but WITHOUT ANY WARRANTY; without even the implied warranty of
!> MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!> GNU General Public License for more details.
!>
!> @copyright You should have received a copy of the GNU General Public License
!> along with this program.  If not, see <http://www.gnu.org/licenses/>.
program prog_AdmAP2D

  use mod_initialize, only: Initialize
  use mod_finalize, only: Finalize
  use mod_scheme, only: scheme
  use mod_numerics, only: MaxLenStr

  use mod_tools_time, only: GetTime, Print_Time_End
  use mod_tools_time, only: TimeCounters

  implicit none

  character(len=MaxLenStr) :: mesh_file, info

  call CPU_TIME(TimeCounters%CPU(1))
  TimeCounters%WallTime(1) = GetTime()

#if defined(_GIT_BRANCH_) && defined(_GIT_REVISION_)
  call Initialize(__DATE__, __TIME__, &
    mesh_file, info, &
    _GIT_BRANCH_,_GIT_REVISION_)
#else
  call Initialize(__DATE__, __TIME__, &
    mesh_file, info)
#endif /* defined(_GIT_BRANCH_) && defined(_GIT_REVISION_) */

  call scheme(mesh_file, info)

  TimeCounters%WallTime(2) = GetTime() - TimeCounters%WallTime(1)
  call CPU_TIME(TimeCounters%CPU(2))

  call Print_Time_End()
  call Finalize()

end program prog_AdmAP2D
