!> Wrapper module for the mesh
!>
!> @authors Florian Blachère
!>
!> @copyright © 2017-2018 Université de technologie de Troyes,
!> @copyright © 2016-2017 Université de Versailles Saint-Quentin-en-Yvelines,
!> @copyright © 2013-2018 CNRS,
!> @copyright © 2013-2016 Université de Nantes.
!> @copyright This program is free software: you can redistribute it and/or modify
!> it under the terms of the GNU General Public License as published by
!> the Free Software Foundation, either version 3 of the License, or
!> (at your option) any later version.
!>
!> @copyright This program is distributed in the hope that it will be useful,
!> but WITHOUT ANY WARRANTY; without even the implied warranty of
!> MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!> GNU General Public License for more details.
!>
!> @copyright You should have received a copy of the GNU General Public License
!> along with this program.  If not, see <http://www.gnu.org/licenses/>.

module mod_mesh

#if defined (_MESH_D2P_)
  use mod_mesh_D2P, only: read_msh, create_meshes, free_meshes
  use mod_mesh_D2P, only: MESH_D2P_ENABLE_SMESH, MESH_D2P_ENABLE_DMESH
#elif defined (_MESH_P2D_)
  use mod_mesh_P2D, only: read_msh, create_meshes, free_meshes
#endif /* _MESH_ */

  implicit none

  private
  public read_msh, create_meshes, free_meshes
#if defined (_MESH_D2P_)
  public MESH_D2P_ENABLE_SMESH, MESH_D2P_ENABLE_DMESH
#endif /* _MESH_ */

end module mod_mesh
